extern (Windows)
{
	pragma ( lib, "DxLib.lib" );
	
	int dx_ChangeWindowMode( int Flag ) ;					// ウインドウモードを変更する
	const int dx_TRUE = 1;
	
	int dx_DxLib_Init() ;							// ライブラリ初期化関数
	int dx_LoadGraph(const char *FileName, int NotUse3DFlag ) ;			// 画像ファイルのメモリへの読みこみ
	const int dx_FALSE = 1;
	
	int dx_SetDrawScreen( int DrawScreen ) ;				// 描画先画面のセット
	const int DX_SCREEN_BACK = -2;
	
	int dx_ProcessMessage() ;						// ウインドウズのメッセージループに代わる処理を行う
	int dx_CheckHitKeyAll() ;						// 全キーの押下状態を取得
	int dx_ClearDrawScreen() ;						// 画面の状態を初期化する
	int dx_DrawGraph( int x, int y, int GrHandle, int TransFlag ) ;		// グラフィックの描画
	int dx_ScreenFlip() ;							// 裏画面と表画面を交換する
	int dx_DxLib_End() ;							// ライブラリ使用の終了関数
}

import dxlib;
import std.string : toStringz;

void main()
{
	int x, add, GrHandle;
	
	// ウインドウモードで起動
	ChangeWindowMode(TRUE);

	// 初期化
	if (DxLib_Init() == -1) return;

	// 画像の読み込み
	GrHandle = LoadGraph("Photo.jpg", FALSE);

	// 描画対象を裏画面に
	SetDrawScreen(DX_SCREEN_BACK);

	x = 0;
	add = 8;
	// 閉じられるか、何かキーが押されるまでループ
	while (ProcessMessage() == 0 && CheckHitKeyAll() == 0 ) {
		x += add;
		if (x <= 0 || x >= 640) add = -add;

		// 画面の初期化
		ClearDrawScreen();

		// 画像の描画
		DrawGraph( x, 0, GrHandle, TRUE);

		// 裏画面の内容を表画面に反映
		ScreenFlip();
	}

	// 後始末
	DxLib_End();
}

